# -*- coding: utf-8 -*-
#!/usr/bin/env python

from datetime import datetime
import gspread
from oauth2client.service_account import ServiceAccountCredentials

def  TalkRecord(Speaker,Content,action,spread,googlekey):
    
    scope = ['https://spreadsheets.google.com/feeds',
                    'https://www.googleapis.com/auth/drive'  ]
    credentials = ServiceAccountCredentials.from_json_keyfile_name(googlekey,scope)

    gc = gspread.authorize(credentials)

    wks = gc.open_by_key(spread)

    #現在の時刻を取得
    get_time=datetime.now().strftime("%Y/%m/%d %H:%M:%S")
       
    #InfomationSheetから最新のシート番号の取得
    ws = wks.worksheet('InformationSheet')
    #LatestSheetの取得
    Cell_1=ws.acell('B1')
    #LatestRowの取得
    Cell_2=ws.acell('B2')
    S_No=Cell_1.value
    R_No=Cell_2.value
    print(S_No)
    print(R_No)

    #会話記録用のsheet数が０のとき/行数が1000行単位かチェックで新たなsheetを追加する
    if S_No == str(0) or (int(R_No)+1)-(1000*int(S_No))==1:
        
        #Sheetの追加
        WorkSheet=wks.add_worksheet(title="data"+str(int(S_No)+1),rows="1",cols="5")
        #カラム名を辞書にセット
        cols_value={'0':'No','1':'speaker','2':'content','3':'Action','4':'Time'}

        #アップデート対象のセルを指定
        test=WorkSheet.range('A1:E1')
        #cols_valueの辞書の値をアップデート対象のセルにセットする
        listNo=0
        for cell in test:
            cell.value=cols_value[str(listNo)]
            listNo=listNo+1
            
        #セルのアップデート
        WorkSheet.update_cells(test)
        #InfomationSheetのLatestRow(行数)を更新する
        ws.update_acell('B1',int(S_No)+1)
               
    else:
        #更新するsheetを指定
          WorkSheet=wks.worksheet('data'+str(S_No))
        
    R_No=int(R_No)+1
    #行を追加
    WorkSheet.append_row([R_No,Speaker,Content,action,get_time])

    #InfomationSheetのLatestRow(行数)を更新する
    ws.update_acell('B2',R_No)
    

if __name__ == '__main__':

    s_text='User'
    c_text='こんにちは'
    Action='ini'
    S_sheet="---------------"#URLに含まれているID
    g_key='----------------'#Google サービスキー

    TalkRecord(s_text,c_text,Action,S_sheet,g_key)
